# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.shortcuts import render
from django.contrib.auth.decorators import login_required
from django.http import HttpResponse

from serv.settings import BASIS_PROC_DIR
from version import version

import json

# Create your views here.

def json_mac_show_builder(file):
    jsonList = []
    jsonStr = '{'

    fileTxt = file.read()
    divided = fileTxt.split('\n')

    file.close()

    for line in divided[:-1]:
        jsonStr += ''
        splited = line.split(':', 1)

        try:
            splited[0] = ''.join(splited[0].split())
            splited[1] = ''.join(splited[1].split())
        except IndexError:
            pass

        try:
            jsonStr += '"' + splited[0] + '"' + ': ' + '"' + splited[1] + '"'
        except IndexError:
            jsonStr = jsonStr[0:-1]
            jsonStr += '}'
            jsonList.append(jsonStr)
            jsonStr = '{'
            continue
        jsonStr += ','
    jsonOut = '['

    for json in jsonList:
        jsonOut += json + ','
    jsonOut = jsonOut[0:-1]
    jsonOut += '[]' if jsonOut == '' else ']'

    return jsonOut


# mac api
@login_required
def macApi(request):
    filePath = BASIS_PROC_DIR + '/hash_tables/mac/'
    # show
    if request.method == 'GET':
        try:
            macShowFd = open(filePath + 'show', 'r')
        except FileNotFoundError:
            return

        response = json_mac_show_builder(macShowFd)
    else :
        if request.method == 'POST':
            try:
                macObj = json.loads(request.body)
                # delete
                if 'DELETE_ID' in macObj:
                    if macObj['DELETE_ID'] == -1:
                        macCleanFd = open(filePath + 'clean', 'w')
                        macCleanFd.write("Clean")
                        macCleanFd.close()
                    else:
                        macDelFd = open(filePath + 'delete', 'w')
                        mask = 'MAC:     {}\n' \
                               'VLAN ID: {}\n'
                        splited = macObj['DELETE_ID'].split('_')
                        macDelFd.write(mask.format(
                            splited[1],
                            splited[0]
                        ))
                        macDelFd.close()
                    response = '{"error": "No error"}'
                # add TODO: переписать для mac
                else:
                    mask =  'MAC:     {}\n' \
                            'VLAN ID: {}\n' \
                            'Port:    {}\n' \
                            'Action:  {}\n' \
                            'Static:  {}\n' \
                            'Tc:   0\n\n'
                    try:
                        formatted = mask.format(
                            macObj['MAC'],
                            macObj['VLAN_ID'],
                            macObj['Port'],
                            macObj['Action'],
                            macObj['Static'],
                        )
                        response = '{"error": "No error"}'
                    except KeyError:
                        response = '{"error": "All fields are required!"}'
                        return HttpResponse(response, content_type='applicatin/json')
                    macAddFd = open(filePath + 'add', 'w')
                    macAddFd.write(formatted)
                    macAddFd.close()

            except FileNotFoundError:
                response = '{"error": "Mac add file not found!"}'
                return HttpResponse(response, content_type='applicatin/json')
        else:
            response = '{"error": "invalid method"}'
    return HttpResponse(response, content_type='application/json')

@login_required
def mac_add_page(request):
    return render(request, 'macRecordAdd.html', { 'version': version })


@login_required
def mac_page(request):
    return render(request, 'macTable.html', { 'version': version })

