# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.shortcuts import render
from django.contrib.auth.decorators import login_required
from django.http import HttpResponse

from serv.settings import BASIS_PROC_DIR
from version import version

import json

# Create your views here.

def json_port_settings_builder(filesPath):
    jsonResult = '['
    i = 1

    while i <= 16:
        file = open(filesPath + 'port' + i.__str__(), 'r')
        fileTxt = file.read()
        divided = fileTxt.split('\n')

        file.close()

        jsonStr = '{"PORT_ID": ' + i.__str__() + ', '

        for line in divided:
            splited = line.split(':', 1)

            try:
                jsonStr += '"' + splited[0] + '"' + ': ' + '"' + splited[1][1:] + '", '
            except IndexError:
                break

        jsonStr = jsonStr[:-2] + '}'
        jsonResult += jsonStr + ', '
        i += 1

    jsonResult = jsonResult[:-2] + ']'
    return jsonResult

@login_required
def port_sett_Api(request):
    if request.method == 'GET':
        response = json_port_settings_builder(BASIS_PROC_DIR + '/port_settings/')
        return HttpResponse(response, content_type='application/json')
    else:
        if request.method == 'POST':
            portSettObj = json.loads(request.body)
            mask = 'TPID: {}\n' \
                   'Fallback_BD_id (dec): {}\n' \
                   'shutdown: {}\n' \
                   'aft: {}\n' \
                   'blockstate: {}\n' \
                   'untag_from_btable: {}\n\n'
            try:
                formatted = mask.format(
                    portSettObj['TPID'],
                    portSettObj['Fallback_BD_id (dec)'],
                    portSettObj['shutdown'],
                    portSettObj['aft'],
                    portSettObj['blockstate'],
                    portSettObj['untag_from_btable']
                )
                response = '{"error": "No error"}'
                macAddFd = open(BASIS_PROC_DIR + '/port_settings/port' + portSettObj['PORT_ID'].__str__(), 'w')
                macAddFd.write(formatted)
                macAddFd.close()
            except KeyError:
                response = '{"error": "All fields are required!"}'

            return HttpResponse(response, content_type='application/json')

@login_required
def port_sett_page(request):
    return render(request, 'portSettings.html', { 'version': version })
