# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.shortcuts import render

from django.contrib.auth.decorators import login_required
from django.http import HttpResponse

from version import version
from serv.settings import BASIS_PROC_DIR

import json


# Create your views here.
def json_queue_settings_builder(filesPath):
    jsonResult = '['
    i = 1

    while i <= 16:
        j = 1
        jsonStr = '{"PORT_ID": ' + i.__str__() + ', '
        jsonStr += '"settings": ['

        while j <= 8:
            file = open(filesPath + 'port' + i.__str__() + '_queues', 'w')
            file.write('Queue add: 0\n')
            file.write('Queue number: ' + j.__str__() + '\n\n')
            file.close()

            file = open(filesPath + 'port' + i.__str__() + '_queues', 'r')
            fileTxt = file.read()
            divided = fileTxt.split('\n')

            file.close()

            jsonStr += '{'

            for line in divided:
                splited = line.rsplit(':', 1)

                try:
                    jsonStr += '"' + splited[0] + '"' + ': ' + '"' + splited[1][1:] + '", '
                except IndexError:
                    file.close()
                    break
            jsonStr = jsonStr[:-2] + '}, '
            j += 1

        jsonStr = jsonStr[:-2] + ']}'
        jsonResult += jsonStr + ', '
        i += 1

    jsonResult = jsonResult[:-2] + ']'
    return jsonResult


@login_required
def queue_sett_Api(request):
    if request.method == 'GET':
        response = json_queue_settings_builder(BASIS_PROC_DIR + '/queue_settings/')
        return HttpResponse(response, content_type='application/json')
    else:
        if request.method == 'POST':
            portSettObj = json.loads(request.body)
            resetMask =	'Queue add: 0\n'\
                        'Queue number: {}\n'\
                        'Queue weight: 1280\n'\
                        'Scheduler number: 1\n'\
                        'Scheduler input: 1\n'\
                        'Queue management: 0\n'\
                        'Max queue size: 0\n'\
                        'Min queue size: 0\n'\
                        'Drop probability: 0 0 0 0 0 0 0 0\n'\
                        'Clear queue counters: 1\n\n'
            mask =	'Queue add: 1\n'\
                    'Queue number: {}\n'\
                    'Queue weight: {}\n'\
                    'Scheduler number: {}\n'\
                    'Scheduler input: {}\n'\
                    'Queue management: {}\n'\
                    'Max queue size: {}\n'\
                    'Min queue size: {}\n'\
                    'Drop probability: 0 0 0 0 0 0 0 0\n'\
                    'Clear queue counters: 0\n'\
                    'Queue tx counter: 0\n'\
                    'Queue drop counter: 0\n'\
                    'Queue pck counter: 0\n\n'

            try:
                formatted = ""
                if portSettObj['RESET_F']:
                    formatted = resetMask.format(portSettObj['Queue number'])
                else:
                    formatted = (mask).format(
                        portSettObj['Queue number'],
                        portSettObj['Queue weight'],
                        portSettObj['Scheduler number'],
                        portSettObj['Scheduler input'],
                        portSettObj['Queue management'],
                        portSettObj['Max queue size'],
                        portSettObj['Min queue size']
                    )
                response = '{"error": "No error"}'
                macAddFd = open(BASIS_PROC_DIR + '/queue_settings/port' + portSettObj['PORT_ID'].__str__() + '_queues', 'w')
                macAddFd.write(formatted)
                macAddFd.close()
            except KeyError:
                response = '{"error": "All fields are required!"}'

            return HttpResponse(response, content_type='application/json')


@login_required
def queue_sett_page(request):
    return render(request, 'queueSettings.html', { 'version': version })
