# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.shortcuts import render

from django.contrib.auth.decorators import login_required
from django.http import HttpResponse

from version import version
from serv.settings import BASIS_PROC_DIR

import json


# Create your views here.

def json_scheduler_settings_builder(filesPath):
    jsonResult = '['
    i = 1

    while i <= 16:
        file = open(filesPath + 'port' + i.__str__() + '_schedulers', 'r')

        fileTxt = file.read()
        divided = fileTxt.split('\n')

        file.close()

        jsonStr = '{"PORT_ID": ' + i.__str__() + ', '
        jsonStr += '"settings": ['

        jsonStr += '{'

        for line in divided[1:]:
            splited = line.split(':', 1)

            try:
                if splited[1] == ' ---':
                    jsonStr = jsonStr[:-2] + '}, {'
                    continue
                jsonStr += '"' + splited[0] + '"' + ': ' + '"' + splited[1][1:] + '", '
            except IndexError:
                break


        jsonStr = jsonStr[:-2] + '}]}'
        jsonResult += jsonStr + ', '
        i += 1

    jsonResult = jsonResult[:-2] + ']'
    return jsonResult


@login_required
def scheduler_sett_Api(request):
    if request.method == 'GET':
        response = json_scheduler_settings_builder(BASIS_PROC_DIR + '/scheduler_settings/')
        return HttpResponse(response, content_type='application/json')
    else:
        if request.method == 'POST':
            portSettObj = json.loads(request.body)
            path = BASIS_PROC_DIR + "/scheduler_settings/port" + portSettObj['PORT_ID'].__str__() + "_schedulers"
            print(portSettObj)
            mask = '--- Scheduler 1 settings: ---\n' \
                   'Scheduler algo type: {}\n' \
                   'Sch2 input to which Sch1 is going: {}\n'\
                   'Weight queue of Sch2 input which Sch1 is going: {}\n'\
                   '--- Scheduler 2 settings: ---\n' \
                   'Scheduler algo type: {}\n'
            try:
                formatted = mask.format(
                    portSettObj['settings'][0]['Scheduler algo type'],
                    portSettObj['settings'][0]['Sch2 input to which Sch1 is going'],
                    portSettObj['settings'][0]['Weight queue of Sch2 input which Sch1 is going'],

                    portSettObj['settings'][1]['Scheduler algo type']
                )
                response = '{"error": "No error"}'
                macAddFd = open(BASIS_PROC_DIR + '/scheduler_settings/port' + portSettObj['PORT_ID'].__str__() + '_schedulers', 'w')
                macAddFd.write(formatted)
                macAddFd.close()
            except KeyError:
                response = '{"error": "All fields are required!"}'

            return HttpResponse(response, content_type='application/json')


@login_required
def scheduler_sett_page(request):
    return render(request, 'schedulerSettings.html', { 'version': version })
