# -*- coding: utf-8 -*-
"""serv URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/1.11/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  url(r'^$', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  url(r'^$', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.conf.urls import url, include
    2. Add a URL to urlpatterns:  url(r'^blog/', include('blog.urls'))
"""

from django.conf import settings
from django.conf.urls.static import static

from django.conf.urls import url, include
from django.contrib import admin

from django.contrib.auth.views import LoginView, LogoutView
from core.views import temperApi
from version import version

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^login/$', LoginView.as_view(template_name='login.html', extra_context={'version': version}), name='login'),
    url(r'^logout/$', LogoutView.as_view(template_name='logout.html', extra_context={'version': version}), name='logout'),

    url(r'^temper/api/$', temperApi, name='logout'),

    url(r'^vlan/', include('show.urls')),
    url(r'^port_settings/', include('port_settings.urls')),
    url(r'^mac/', include('machs.urls')),
    url(r'^emstat/', include('emstatistics.urls')),
    url(r'^scheduler_settings/', include('scheduler_settings.urls')),
    url(r'^queue_settings/', include('queue_settings.urls')),
    url(r'^shaper_settings/', include('shaper_settings.urls')),
    # url(r'^net_utils/', include('net_utils.urls')),
    url(r'^', include('emstatistics.urls')),

] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
