# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.shortcuts import render
from django.contrib.auth.decorators import login_required
from django.http import HttpResponse

from version import version
from serv.settings import BASIS_PROC_DIR

import json

# Create your views here.

def json_vlan_show_builder(file):
    jsonList = []
    jsonStr = '{'

    fileTxt = file.read()
    divided = fileTxt.split('\n')

    file.close()

    for line in divided[:-1]:
        jsonStr += ''
        splited = line.split(':', 1)

        try:
            splited[0] = ''.join(splited[0].split())
            splited[1] = ''.join(splited[1].split())
        except IndexError:
            pass

        try:
            jsonStr += '"' + splited[0] + '"' + ': ' + '"' + splited[1] + '"'
        except IndexError:
            jsonStr = jsonStr[0:-1]
            jsonStr += '}'
            jsonList.append(jsonStr)
            jsonStr = '{'
            continue
        jsonStr += ','
    jsonOut = '['

    for json in jsonList:
        jsonOut += json + ','
    jsonOut = jsonOut[0:-1]
    jsonOut += '[]' if jsonOut == '' else ']'

    return jsonOut



# vlan api
@login_required
def vlanApi(request):
    filePath = BASIS_PROC_DIR + '/hash_tables/vlan/'
    # show
    if request.method == 'GET':
        try:
            vlanShowFd = open(filePath + 'show', 'r')
        except FileNotFoundError:
            return

        response = json_vlan_show_builder(vlanShowFd)
    else :
        if request.method == 'POST':
            try:
                vlanObj = json.loads(request.body)
                print(vlanObj)
                # delete
                if 'DELETE_ID' in vlanObj:
                    if vlanObj['DELETE_ID'] == -1:
                        vlanCleanFd = open(filePath + 'clean', 'w')
                        vlanCleanFd.write("Clean")
                        vlanCleanFd.close()
                    else:
                        vlanDelFd = open(filePath + 'delete', 'w')
                        mask = 'VLAN ID: {}\n'
                        vlanDelFd.write(mask.format(
                            vlanObj['DELETE_ID'],
                        ))
                        vlanDelFd.close()
                    response = '{"error": "No error"}'
                # add
                else:
                    mask = 'VLAN ID:       {}\n'+\
                            'Forward list:  {}\n'+\
                            'Untag list:    {}\n'+\
                            'UnicastHit:    {}\n'+\
                            'UnicastMiss:   {}\n'+\
                            'MulticastHit:  {}\n'+\
                            'MulticastMiss: {}\n'+\
                            'Mstp:          {}\n\n'
                    try:
                        formatted = mask.format(
                           vlanObj['VLAN_ID'],
                           vlanObj['Forward_list'],
                           vlanObj['Untag_list'],
                           vlanObj['UnicastHit'],
                           vlanObj['UnicastMiss'],
                           vlanObj['MulticastHit'],
                           vlanObj['MulticastMiss'],
                           vlanObj['Mstp'],
                        )
                        response = '{"error": "No error"}'
                    except KeyError:
                        response = '{"error": "All fields are required!"}'
                        return HttpResponse(response, content_type='applicatin/json')
                    print(filePath)
                    vlanAddFd = open(filePath + 'add', 'w')
                    vlanAddFd.write(formatted)
                    vlanAddFd.close()

            except FileNotFoundError:
                response = '{"error": "Vlan add file not found!"}'
                return HttpResponse(response, content_type='applicatin/json')
        else:
            response = '{"error": "invalid method"}'
    return HttpResponse(response, content_type='application/json')


@login_required
def vlan_add_page(request):
    return render(request, 'vlanRecordAdd.html', { 'version': version })


@login_required
def vlan_page(request):
    return render(request, 'vlanTable.html', { 'version': version })
