import React from 'react';
import ReactDOM from 'react-dom';

import apiUrls from '../../apiUrls'
import Loading from '../loading.gif';

class Stat extends React.Component {


    showStat = (e) => {
        let parent = e.target.parentElement;
        let children = parent.getElementsByClassName('stat-block');
        for (let i = 0; i < children.length; i++) {
            children[i].hidden = !(children[i].hidden);
        }
    };

    render() {
        let txstat = this.props.item['TX statistic'].map(
            item => <div key={item.id}> { item } </div>
        );
        let rxstat = this.props.item['RX statistic'].map(
            item => <div key={item.id}> { item } </div>
        );
        let classstat = this.props.item['Classificator statistic'].map(
            item => <div key={item.id}> { item } </div>
        );
        let bytesstat = this.props.item['Bytes statistic'].map(
            item => <div key={item.id}> {item} </div>
        );
        return (
            <div className="stat-main-block">
                <div className="stat-button" onClick={ this.showStat }>EMAC { this.props.item.EMAC_ID } statistic</div>
                <div className="stat-block" hidden>
                    <div className="stat-header">TX statistics</div>
                    { txstat }
                </div>

                <div className="stat-block" hidden>
                    <div className="stat-header">RX statistics</div>
                    { rxstat }
                </div>

                <div className="stat-block" hidden>
                    <div className="stat-header">Classificator statistics</div>
                    { classstat }
                </div>

                <div className="stat-block" hidden>
                    <div className="stat-header">Bytes statistics</div>
                    { bytesstat }
                </div>
            </div>
        )
    }
}

class EmStat extends React.Component {

    constructor(props) {
        super(props);
        this.state = {isLoading: true, active: [true]};
    }

    onChange = (e) => {
        this.setState({[e.target.name]: e.target.value});
    };


    load = () => {
        fetch(
            apiUrls.emstat,
            { credentials: 'include' }
        ).then(
            (body) => body.json()
        ).then(
            (json) => {
                return this.setState({isLoading: false, statList: json});
            }
        );
    };


    componentDidMount(){
        this.load();
        this.interval = setInterval(() => this.load(), 5000);
    }

    render() {
        if (this.state.isLoading) {
            return (
                <div> <img src={ Loading } className={'loading-img'} id={this.props.name + 'loading-img'}/></div>
            );
        }
        const emStat = this.state.statList.map(
            item => {
                return (
                    <Stat key={ item.EMAC_ID } item={item}/>
                )
            }
        );
        return (
            <div>{ emStat }</div>
        )
    }

}



ReactDOM.render(
    <EmStat />,
    document.getElementById('id_content'),
);