import React from 'react';
import ReactDOM from 'react-dom';

import apiUrls from '../../apiUrls'


class MacRecordAdd extends React.Component {

    constructor(props) {
        super(props);
        this.state = {Action: 0, Static: 0};
    }

    onChange = (e) => {
        e.target.className += (e.target.classList.contains('changed') ?  '' : 'changed');
        this.setState({[e.target.name]: e.target.value});
    };


    handleSubmit  = (e) => {
        e.preventDefault();
        if (this.isValid(e)) {
            this.onClick();
        }
    };

    isValid = (e) => {
        let elems = e.target.form.getElementsByTagName('input');
        let validity = true;
        for (let i = 0; i < elems.length; i++){
            if(!elems[i].validity.valid){
                validity = false;
            }
        }
        console.log(elems);
        if (!validity) {
            alert('You have invalid fields!');
            return false;
        }
        return true;
    };

    onClick = () => {
        fetch(
            apiUrls.macs,
            {
                method: 'POST',
                credentials: 'include',
                body: JSON.stringify(this.state),
                headers: {
                    'X-CSRFToken': getCSRF(),
                    'content-type': 'application/json',
                }
            }).then(
            body => body.json(),
        ).then(
            json => console.log(json)
        );
    };

    render() {
        return (
            <form method="post">
                <div align="center">
                    <table>
                        <tbody>
                            <tr>
                                <td style={{'textAlign': 'right'}}>
                                    <label className="left">MAC </label>
                                    <input
                                        placeholder="ff:ff:ff:ff:ff:ff"
                                        title="Format: ff:ff:ff:ff:ff:ff"
										pattern="^([0-9a-fA-F]{2}:){5}[0-9a-fA-F]{2}$"
										cols="50"
                                        onChange={ this.onChange }
                                        type="text"
                                        value={ this.state.MAC === undefined ? "" : this.state.MAC }
                                        name="MAC"
                                        required
                                    /><br/>
    {/*// vlan 0-4095 port 0-16 action читать в спец static 1 - static, 0 -dynamic */}
    {/**/}
                                    <label className="left">VLAN ID </label>
                                    <input
                                        placeholder="4095"
                                        min="0"
                                        max="4095"
                                        title="0-4095"
                                        onChange={ this.onChange }
                                        type="number"
                                        value={ this.state.VLAN_ID === undefined ? "" : this.state.VLAN_ID }
                                        name="VLAN_ID"
                                        required
                                    /><br/>

                                    <label className="left">Port </label>
                                    <input
                                        required
                                        placeholder="16"
                                        min="0"
                                        max="16"
                                        title={'0-16\n16 - host'}
                                        onChange={ this.onChange }
                                        type="number"
                                        value={ this.state.Port === undefined ? "" : this.state.Port }
                                        name="Port"
                                    /><br/>

                                    <label className="left">Action </label>
                                    <select name="Action" value={this.state.Action} onChange={ this.onChange } required>
                                        <option value="0">Forwarding using forward_list ports</option>
                                        <option value="1">Broadcast using forward_list ports</option>
                                        <option value="2">Catch packet for processing in host-processor</option>
                                        <option value="3">Drop packet</option>
                                        <option value="4">Inherit VLAN table action</option>
                                        <option value="5">Forward port list & VLAN table forward list</option>
                                        <option value="6">Porcessing using COS settings</option>
                                    </select><br/>

                                    <label className="left">Static</label>
                                    <select name="Static" value={this.state.Static} onChange={ this.onChange } required>
                                        <option value="0">Dynamic</option>
                                        <option value="1">Static</option>
                                    </select><br/>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <input type="submit" onClick={ this.handleSubmit }/>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
            </form>
        )
    }

}

ReactDOM.render(
    <MacRecordAdd />,
    document.getElementById('id_content'),
);