import React from 'react';
import ReactDOM from 'react-dom';

class SecondaryMenuBlock extends React.Component
{
	render()
	{
		return (
			<div>
				<a href={ this.props.link }>
					<div className="menu-button-secondary">
						{ this.props.name }
					</div>
				</a>
			</div>
		);
	}
}

class PrimaryMenuBlock extends React.Component
{
	handleClick = (e) => { this.props.onClick( this.props.name ); }

	render()
	{
		let block = 
			<div className="menu-button-block">
				<div className="menu-button-main" name={ this.props.name } onClick={ this.handleClick }>{ this.props.name }</div>
				<div hidden={ this.props.active !== this.props.name }>
					{ this.props.children }
				</div>
			</div>;
		if (this.props.link === undefined)
			return (block);
		return (<a href={ this.props.link }>{ block }</a>);
	}
}

class MainMenu extends React.Component
{
	constructor(props)
	{
		super(props);
		this.state = { active: "" };
	}

	handleClick = ( primBlock ) => {
		if (this.state.active === primBlock)
			primBlock = ""
		this.setState({ active: primBlock });
	}

	render()
	{
		return (
			<div className="menu-main">
				<PrimaryMenuBlock name="Statistics" link="/emstat/" active={ this.state.active }/>
				<PrimaryMenuBlock name="Truncing" active={ this.state.active } onClick={ this.handleClick }>
					<SecondaryMenuBlock name="Vlan" link="/vlan/"/>
					<SecondaryMenuBlock name="Vlan add" link="/vlan/add/"/>
					<SecondaryMenuBlock name="Private Vlan" link="#"/>
				</PrimaryMenuBlock>
				<PrimaryMenuBlock name="MAC" active={ this.state.active } onClick={ this.handleClick }>
					<SecondaryMenuBlock name="Add" link="/mac/add/"/>
					<SecondaryMenuBlock name="Show" link="/mac/"/>
				</PrimaryMenuBlock>
				<PrimaryMenuBlock name="Port settings" active={ this.state.active } onClick={ this.handleClick }>
					<SecondaryMenuBlock name="Speed" link="#"/>
					<SecondaryMenuBlock name="Flow control" link="#"/>
				</PrimaryMenuBlock>
				<PrimaryMenuBlock name="QoS" active={ this.state.active } onClick={ this.handleClick }>
					<SecondaryMenuBlock name="Scheduler" link="#"/>
					<SecondaryMenuBlock name="Shaper" link="#"/>
					<SecondaryMenuBlock name="Queue" link="#"/>
				</PrimaryMenuBlock>
				<PrimaryMenuBlock name="Security" active={ this.state.active } onClick={ this.handleClick }>
					<SecondaryMenuBlock name="Admin panel" link="/admin/"/>
					<SecondaryMenuBlock name="DoS control" link="#"/>
				</PrimaryMenuBlock>
				<PrimaryMenuBlock name="Network protocols" active={ this.state.active } onClick={ this.handleClick }>
					<SecondaryMenuBlock name="RSTP" link="#"/>
					<SecondaryMenuBlock name="etc" link="#"/>
				</PrimaryMenuBlock>
				<PrimaryMenuBlock name="Network utils" active={ this.state.active } onClick={ this.handleClick }>
					<SecondaryMenuBlock name="Ping" link="#"/>
					<SecondaryMenuBlock name="Traceroute" link="#"/>
				</PrimaryMenuBlock>
				<PrimaryMenuBlock name="Hardware settings" active={ this.state.active } onClick={ this.handleClick }>
					<SecondaryMenuBlock name="Queue" link="/queue_settings/"/>
					<SecondaryMenuBlock name="Port" link="/port_settings/"/>
					<SecondaryMenuBlock name="Scheduler" link="/scheduler_settings/"/>
					<SecondaryMenuBlock name="Shaper" link="/shaper_settings/"/>
				</PrimaryMenuBlock>
			</div>
		);
	}
}

ReactDOM.render(
    <MainMenu />,
    document.getElementById('id_main_menu'),
);