import React from 'react';

import Arrow from '../arrow_down.png';


export default class Switcher extends React.Component {

    handleClick = (portNumber) => {
        let portlistElem = document.getElementById(this.props.name + 'list');
        portlistElem.hidden = true;
        let img = document.getElementById(this.props.name + 'arrow-img');
        img.style.transform = portlistElem.hidden === true ? "none" : "rotate(180deg)";
        this.props.setActive(portNumber);
    };

    showPortList = (e) => {
        let portlistElem = document.getElementById(this.props.name + 'list');
        portlistElem.hidden = !portlistElem.hidden;
        let img = document.getElementById(this.props.name + 'arrow-img');
        img.style.transform = portlistElem.hidden === true ? "none" : "rotate(180deg)";
    };

    render() {

        let arr = [];
        for (let i = this.props.startPoint; i <= this.props.entriesNumber - 1 + this.props.startPoint; i++) {
            arr[i] = i;
        }

        const portList = arr.map(
            item => {
                return (
                    <SwitcherCase key={ item } choosen={ item === this.props.activePort } name={ this.props.name } portNumber={item} onClick={this.handleClick}/>
                )
            }
        );

        return (
            <div className="switcher">
                <div className="switcher-main" onClick={this.showPortList}>
                    { this.props.name } { this.props.activePort }
                    <div className="arrow"><img src={ Arrow } className={'arrow-img'} id={this.props.name + 'arrow-img'}/></div>
                </div>
                <div className="switcher-case-b" id={this.props.name + 'list'} hidden>
                    { portList }
                </div>
            </div>
        )
    }


}

class SwitcherCase extends React.Component {

    handleClick = (e) => {
        this.props.onClick(this.props.portNumber);
    };

    handleEnter = (e) => {
        e.target.className = "switcher-case active";
    };

    handleLeave = (e) => {
        e.target.className = "switcher-case";
    };

    render() {
        if (this.props.choosen) {
            return (
                <div
                    className="switcher-case active"
                    onClick={this.handleClick}>
                    { this.props.name } {this.props.portNumber}
                </div>
            )
        }
        return (
            <div
                className="switcher-case"
                onClick={this.handleClick}
                onMouseEnter={ this.handleEnter }
                onMouseLeave={ this.handleLeave }>
                { this.props.name } {this.props.portNumber}
            </div>
        )
    }
}
