import React from 'react';
import ReactDOM from 'react-dom';

import apiUrls from '../../apiUrls'

class Temper extends React.Component {

    constructor(props) {
        super(props);
        this.state = {
            isLoading: true,
            temp: {
                Basis: '--',
                Board: '--'
            }
        };
    }

    load = () => {
        fetch(
            apiUrls.temper,
            { credentials: 'include' }
        ).then(
            (body) => body.json()
        ).then(
            (json) => {
                if (json.Basis === 'UNAVAILABLE') {
                    let state = this.state;
                    state.temp.Board = (json.Board === 'UNAVAILABLE' ? state.temp.Board : json.Board);
                    return this.setState({isLoading: false, temp: state.temp});
                } else
                if (json.Board === 'UNAVAILABLE') {
                    let state = this.state;
                    state.temp.Basis = (json.Basis === 'UNAVAILABLE' ? state.temp.Basis : json.Basis);
                    return this.setState({isLoading: false, temp: state.temp});
                }
                return this.setState({isLoading: false, temp: json});
            }
        );
    };

    componentDidMount(){
        this.load();
        let timer;
        let tick = () => {
            this.load();
            if (((this.state.temp.Basis === '--')||(this.state.temp.Board === '--'))) {
                timer = setTimeout(tick, 2500);
            }else this.interval = setInterval(() => this.load(), 15000);// 15 sec
        };
        tick();
    }

    render() {
        if (this.state.isLoading) {
            return (<div className="temp">
				<div>Temperature:</div>
				<div>Basis: --</div>
				<div>Board: --</div>
			</div>);
        }

        return (
            <div className="temp">
                <div>Temperature:</div>
                <div>Basis: { this.state.temp.Basis }</div>
                <div>Board: { this.state.temp.Board }</div>
            </div>
        )
    }
}





ReactDOM.render(
    <Temper />,
    document.getElementById('temperature'),
);