import React from 'react';
import ReactDOM from 'react-dom';

import apiUrls from '../../apiUrls'


class VlanRecordAdd extends React.Component {

    constructor(props) {
        super(props);
        this.state = {MulticastMiss: 0, MulticastHit: 0, UnicastMiss: 0, UnicastHit: 0, Mstp: 0};
    }

    handleSubmit  = (e) => {
        e.preventDefault();
        if(this.isValid(e)) {
            this.onClick();
        }
    };

    isValid = (e) => {
        let elems = e.target.form.getElementsByTagName('input');
        let validity = true;
        for (let i = 0; i < elems.length; i++){
            if(!elems[i].validity.valid){
                validity = false;
            }
        }
        console.log(elems);
        if (!validity) {
            alert('You have invalid fields!');
            return false;
        }
        return true;
    };

    onChange = (e) => {
		let prevState = this.state;
		prevState[e.target.name] = e.target.value;
        e.target.className += (e.target.classList.contains('changed') ?  '' : 'changed');
        this.setState(prevState);
    };

    onClick = () => {
        fetch(
            apiUrls.vlans,
            {
                method: 'POST',
                credentials: 'include',
                body: JSON.stringify(this.state),
                headers: {
                    'X-CSRFToken': getCSRF(),
                    'content-type': 'application/json',
                }
            }).then(
            body => body.json(),
        ).then(
            json => console.log(json)
        );
    };

    render() {
        return (
            <form method="post" style={{textAlign : 'right'}}>
                <div align="center">
                    <table>
                        <tbody>
                            <tr>
                                <td style={{'textAlign': 'right'}}>
                                    <label className="left">Vlan ID</label>
                                    <input
                                        required
                                        placeholder="4095"
                                        min="0"
                                        max="4095"
                                        title="0-4095"
                                        onChange={ this.onChange }
                                        type="number"
                                        value={ this.state.VLAN_ID  === undefined ? "" : this.state.VLAN_ID }
                                        name="VLAN_ID"
                                    /><br/>

                                    <label className="left">Forward list</label>
                                    <input
                                        required
                                        onChange={ this.onChange }
                                        type="text"
                                        value={ this.state.Forward_list  === undefined ? "" : this.state.Forward_list }
                                        name="Forward_list"
                                    /><br/>

                                    <label className="left">Untag list</label>
                                    <input required onChange={ this.onChange } type="text" value={ this.state.Untag_list === undefined ? "" : this.state.Untag_list } name="Untag_list"/><br/>

                                    <label className="left">Unicast hit</label>
                                    <select name="UnicastHit" value={this.state.UnicastHit} onChange={ this.onChange } required>
										<option value="0">Forwarding using forward_list ports</option>
                                        <option value="1">Broadcast using forward_list ports</option>
                                        <option value="2">Catch packet for processing in host-processor</option>
                                        <option value="3">Drop packet</option>
                                        <option value="4">Inherit VLAN table action</option>
                                        <option value="5">Forward port list & VLAN table forward list</option>
                                        <option value="6">Porcessing using COS settings</option>
                                    </select><br/>

                                    <label className="left">Unicast miss</label>
                                    <select name="UnicastMiss" value={this.state.UnicastMiss} onChange={ this.onChange } required>
										<option value="0">Forwarding using forward_list ports</option>
                                        <option value="1">Broadcast using forward_list ports</option>
                                        <option value="2">Catch packet for processing in host-processor</option>
                                        <option value="3">Drop packet</option>
                                        <option value="4">Inherit VLAN table action</option>
                                        <option value="5">Forward port list & VLAN table forward list</option>
                                        <option value="6">Porcessing using COS settings</option>
                                    </select><br/>

                                    <label className="left">Multicast hit</label>
                                    <select name="MulticastHit" value={this.state.MulticastHit} onChange={ this.onChange } required>
										<option value="0">Forwarding using forward_list ports</option>
                                        <option value="1">Broadcast using forward_list ports</option>
                                        <option value="2">Catch packet for processing in host-processor</option>
                                        <option value="3">Drop packet</option>
                                        <option value="4">Inherit VLAN table action</option>
                                        <option value="5">Forward port list & VLAN table forward list</option>
                                        <option value="6">Porcessing using COS settings</option>
                                    </select><br/>

                                    <label className="left">Multicast miss</label>
                                    <select name="MulticastMiss" value={this.state.MulticastMiss} onChange={ this.onChange } required>
										<option value="0">Forwarding using forward_list ports</option>
                                        <option value="1">Broadcast using forward_list ports</option>
                                        <option value="2">Catch packet for processing in host-processor</option>
                                        <option value="3">Drop packet</option>
                                        <option value="4">Inherit VLAN table action</option>
                                        <option value="5">Forward port list & VLAN table forward list</option>
                                        <option value="6">Porcessing using COS settings</option>
                                    </select><br/>

                                    <label className="left">Mstp</label>
									<select name="Mstp" value={this.state.Mstp} onChange={ this.onChange } required>
										<option value="0">Forwarding using forward_list ports</option>
                                        <option value="1">Broadcast using forward_list ports</option>
                                        <option value="2">Catch packet for processing in host-processor</option>
                                        <option value="3">Drop packet</option>
                                        <option value="4">Inherit VLAN table action</option>
                                        <option value="5">Forward port list & VLAN table forward list</option>
                                        <option value="6">Porcessing using COS settings</option>
									</select>
                                </td>
                            </tr>
                            <tr><td><input type="submit" onClick={ this.handleSubmit }/></td></tr>
                        </tbody>
                    </table>
                </div>
            </form>
        )
    }

}

ReactDOM.render(
    <VlanRecordAdd />,
    document.getElementById('id_content'),
);